//===============================================================================
//  BD7411G.cpp
//
// Copyright (c) 2021 ROHM Co.,Ltd.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//===============================================================================
#include <Arduino.h>
#include <BD7411G.h>

BD7411G::BD7411G(uint32_t connect_area)
{
    connect_pin = connect_area;

    init_flag = INIT_NG;
}

BD7411G::~BD7411G()
{
    connect_pin = ANALOG_NON_USE_PIN;

    init_flag = INIT_NG;
}

int32_t BD7411G::init()
{
    if ((connect_pin == ANALOG_1_OUT_PIN) || (connect_pin == ANALOG_2_OUT_PIN)) {
        init_flag = INIT_OK;

        pinMode(connect_pin, INPUT);
    } else {
        init_flag = INIT_NG;
    }

    return init_flag;
}

int32_t BD7411G::get_val(uint8_t *data)
{
    if (init_flag == INIT_OK) {
        *data = (uint8_t)digitalRead(connect_pin);
    } else {
        *data = DATA_ERROR;
    }

    return init_flag;
}

float32 BD7411G::get_version()
{
    return DRIVER_VERSION;
}
